#ifndef _XSTRING_H_
#define _XSTRING_H_

/** actual XString structure */

typedef struct XString
{
  char * str;
  int length;
} XString;

/** XString creation (must call xstrDestroy() to free them) */

XString * xstrCreate(char * str);
XString * xstrSubstr(char * str, int offset, int len);
XString * xstrXSubstr(XString * xstr, int offset, int len);

/** XString manipulation */

void xstrAppend(XString * xstr, char * str);

/** XString querying */

char xstrCharAt(XString * xstr, int index);
int xstrEquals(XString * xstr, char * str);
int xstrLength(XString * xstr);
char * xstrString(XString * xstr);
int xstrContains(XString * xstr, char c);
int xstrIndexOf(XString * xstr, char c);
int xstrLastIndexOf(XString * xstr, char c);

/** XString destruction */

void xstrDestroy(XString * xstr);

#endif
